---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:10
---

local _, ZenThreat = ...
ZenThreat.units = {}
ZenThreat.playerUnitId = nil

function ZenThreat:OnLoad()
    ZenThreat:Print("loaded")
end

function ZenThreat:UpdateNamePlates()
    for i, frame in ipairs(C_NamePlate.GetNamePlates()) do
        local unitFrame = frame.UnitFrame
        self:ProcessNamePlate(frame, unitFrame, unitFrame.displayedUnit, function(zenFrame, frame, unitFrame)
            zenFrame:SetFrameLevel(6)
            zenFrame:SetFrameStrata("HIGH")
            zenFrame.text:SetPoint("LEFT", unitFrame.healthBar, 2, 0)
        end)
     end
end
function ZenThreat:UpdateElvUINamePlates()
    for i, frame in ipairs(C_NamePlate.GetNamePlates()) do
        local unitFrame = frame.unitFrame
        self:ProcessNamePlate(frame, unitFrame, unitFrame.unit, function(zenFrame, frame, unitFrame)
            zenFrame:SetFrameLevel(6)
            zenFrame:SetFrameStrata("HIGH")
            zenFrame.text:SetPoint("LEFT", unitFrame.Health, 2, 0)
        end)
     end
end
function ZenThreat:UpdatePlaterNamePlates()
    for i, frame in ipairs(C_NamePlate.GetNamePlates()) do
        local unitFrame = frame.unitFrame
        self:ProcessNamePlate(frame, unitFrame, unitFrame.namePlateUnitToken, function(zenFrame, frame, unitFrame)
            local relativeTo = _G[frame:GetName().."PlaterUnitFrameHealthBar"]
            zenFrame.text:SetParent(relativeTo)
            zenFrame.text:SetDrawLayer("OVERLAY", 7)
            zenFrame.text:SetPoint("LEFT", 2, 0)
        end)
     end
end
function ZenThreat:ProcessNamePlate(frame, unitFrame, unit, callback)
    local unitGUID = unit and UnitGUID(unit) or nil
    local isSameUnit = unitGUID == unitFrame.unitID
    unitFrame.unitID = unitGUID
    if not frame.ZenThreatFrame then
        local f = CreateFrame("Frame", frame:GetName().."ZenThreatFrame", frame)
        frame.ZenThreatFrame = f
        f:SetFrameStrata(frame:GetFrameStrata())
        f:SetPoint("LEFT", 0, 0)
        local font = f:CreateFontString("$parentText","OVERLAY", "GameFontHighlightSmall")
        f.text = font
        font:SetText("")
        font:SetDrawLayer("ARTWORK", 7)
        font:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
        f.SetValue = function(self, value)
            font:SetText(value)
        end
        f.GetThreatDiff = function(self)
            local index = self.threatsIndexes[ZenThreat.playerUnitId]
            local value
            if index then
                if #self.threats > 1 then
                    if index == 1 then
                        value = self.threats[index].value - self.threats[2].value
                    else
                        value = self.threats[index].value - self.threats[1].value
                    end
                else
                    value = self.threats[index] and self.threats[index].value or nil
                end
            end
            return value and math.floor(value / 100 ) or nil
        end
        f.UpdateThreat = function(self, unit, value)
            if value == nil then
                local index = self.threatsIndexes[unit]
                if index then
                    self.threats[index] = nil
                    self.threats = table.removeNil(self.threats)
                end
            else
                if not self.threatsIndexes[unit] then
                    local index = #self.threats + 1
                    self.threats[index] = {
                        unit = unit,
                        value = value
                    }
                    self.threatsIndexes[unit] = index
                else
                    local index = self.threatsIndexes[unit]
                    if index and self.threats[index] then
                        self.threats[index].value = value
                    end
                end
            end
        end
        f.UpdateValue = function(self)
            table.sort(self.threats, function(a,b) return a.value > b.value end)
            for j, v in ipairs(self.threats) do
                self.threatsIndexes[v.unit] = j
            end
            self:SetValue(self:GetThreatDiff() or "")
        end
        f.Init = function(self)
            self.threats = {
            }
            self.threatsIndexes = {
            }
            self:UpdateValue()
        end
        f.Reset = function(self)
            self:Init()
        end
        f:Init()
        if callback then
            callback(frame.ZenThreatFrame, frame, unitFrame, unit)
        end
    elseif not isSameUnit or not unit then
        frame.ZenThreatFrame:Reset()
    end
end
function ZenThreat:UpdateUnits()
        for unit, _ in ipairs(self.units) do
        self.units[unit] = nil
    end
    if IsInRaid() then
        local members = GetNumGroupMembers()
        for i = 1, members do
            self:AddUnit("raid"..i)
        end
    elseif IsInGroup() then
        local members = GetNumGroupMembers()
        for i = 1, members do
           self:AddUnit("party"..i)
        end
        self:AddUnit("player")
    else
        self:AddUnit("player")
    end
end
function ZenThreat:AddUnit(unitId)
    self.units[unitId] = {}
    local unitName = UnitName(unitId)
    local playerName = UnitName("player")
    if unitName == playerName then
        self.playerUnitId = unitId
    end
end
function ZenThreat:UpdateThreat(targetUnit)
    local nameplate = C_NamePlate.GetNamePlateForUnit(targetUnit)
    if nameplate then
        local zenFrame = nameplate.ZenThreatFrame
        for unit, _ in pairs(self.units) do
            local isTanking, status, threatpct, rawthreatpct, threatValue = UnitDetailedThreatSituation(unit, targetUnit)
            zenFrame:UpdateThreat(unit, threatValue)
        end
        zenFrame:UpdateValue()
    end

end

function ZenThreat:IsAddonEnabled(name)
    local name, title, notes, loadable, reason, security, newVersion = GetAddOnInfo(name)
    return loadable
end
