---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:12
---

local AddonName, ZenThreat = ...

local addonsToCheck = {
    [ZenThreat.ADDONS.ElvUI] = false,
    [ZenThreat.ADDONS.Plater] = false,
}

local addonsCheckCallback = {
    [ZenThreat.ADDONS.ElvUI] = function()
        ZenThreat.isElvUI = true
        return ElvUI ~= nil
    end,
    [ZenThreat.ADDONS.Plater] = function()
        return Plater ~= nil
    end
}

ZenThreat.REQUIRED_ADDONS = {
    [AddonName] = false,
}

function ZenThreat:CheckCompatibility()
    for k,v in pairs(addonsToCheck) do
        local loadable = ZenThreat:IsAddonEnabled(k)
        local alreadyLoaded = false
        if loadable and addonsCheckCallback[k] then
            alreadyLoaded = addonsCheckCallback[k]()
        end
        if loadable then
            ZenThreat.REQUIRED_ADDONS[k] = alreadyLoaded
        end
        addonsToCheck[k] = loadable
    end
end
ZenThreat:CheckCompatibility()


ZenThreatConfig = {}

ZenThreatConfig.debug = false


local EventFrame = CreateFrame('Frame')
EventFrame:RegisterEvent('ADDON_LOADED')
EventFrame:RegisterEvent('UNIT_THREAT_LIST_UPDATE')
EventFrame:RegisterEvent('GROUP_ROSTER_UPDATE')
EventFrame:RegisterEvent('PLAYER_ENTERING_WORLD')

ZenThreat.EventFrame = EventFrame;
EventFrame:SetScript('OnEvent', function(self, event, ...)
    if self[event] then
        self[event](self, ...)
    end
end)

local function initAddon()
    EventFrame:UnregisterEvent('ADDON_LOADED')
    EventFrame.ADDON_LOADED = function()  end
    ZenThreat:Debug('All required addons loaded. Initializing...')
    local success = C_ChatInfo.RegisterAddonMessagePrefix(AddonName)
    if success then
        ZenThreat.namePlateAddon = ZenThreat:GetNamePlateAddon()
        ZenThreat:HookEvents()
        ZenThreat:OnLoad()
    else
        ZenThreat:Print("Failed to register messaging event!")
    end
end


function EventFrame:ADDON_LOADED(name)
    local requiredAddon = ZenThreat.REQUIRED_ADDONS[name]
    if requiredAddon ~= nil then
        ZenThreat:Debug('Required addon', name, 'loaded')
        ZenThreat.REQUIRED_ADDONS[name] = true
    end
    local requiredAddonsLoaded = true
    for _, v in pairs (ZenThreat.REQUIRED_ADDONS) do
        if not v then
            requiredAddonsLoaded = false
        end
    end
    if requiredAddonsLoaded then
        initAddon()
    else
        if ZenThreat.isElvUI and ElvUI then
            ZenThreat.isElvUI = ElvUI[1].private.nameplates.enable
            initAddon()
        end
    end
end

function ZenThreat:GetNamePlateAddon()
    for k, v in pairs(addonsToCheck) do
        if v then
            return k
        end
    end
    return self.ADDONS.Blizzard
end



function EventFrame:UNIT_THREAT_LIST_UPDATE(unit)
    pcall(function(u) ZenThreat:UpdateThreat(u) end, unit)
end

function EventFrame:GROUP_ROSTER_UPDATE()
    ZenThreat:UpdateUnits()
end

function EventFrame:PLAYER_ENTERING_WORLD()
    ZenThreat:UpdateUnits()
end
